Unit AET2R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTAE12_p;

procedure AET2R(NM :Integer; N :Integer; LOW :Integer;
                IGH :Integer; var H :Array of Real;
                var WR :Array of Real; var WI :Array of Real;
                var IERR :Integer);

implementation

procedure AET2R(NM :Integer; N :Integer; LOW :Integer;
                IGH :Integer; var H :Array of Real;
                var WR :Array of Real; var WI :Array of Real;
                var IERR :Integer);
var
EN,ENM2,I,ITS,J,K,L,LL,M,MM,MP2,NA :Integer;
MACHEP,NORM,P,Q,R,S,T,W,X,Y,ZZ :Real;
LOG,NOTLAS :Boolean;
const
SYS056 :Real = 1.175495E-38;
SYS051 :Real = 1.192093E-07;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210,_220,_230,_240,_250,_260;
begin
{      SYS056 = SYS055 }
MACHEP := SYS051;
IERR := 0;
NORM := 0.0;
K := 1;
for I:=1 to N do
 begin
  for J:=K to N do
   begin
    NORM := NORM + Abs(H[(I-1)+(J-1)*NM]);
_10:
   end;
  K := I;
  if ( I >=  LOW ) and (  I <=  IGH ) 
   then goto _20;
  WR[I-1] := H[(I-1)+(I-1)*NM];
  WI[I-1] := 0.0;
_20:
 end;
EN := IGH;
T := 0.0;
_30:
if ( EN <  LOW ) 
 then goto _260;
ITS := 0;
NA := EN - 1;
ENM2 := NA - 1;
_40:
for LL:=LOW to EN do
 begin
  L := EN + LOW - LL;
  if ( L =  LOW ) 
   then goto _60;
  S := (Abs(H[(L-2)+(L-2)*NM]) + Abs(H[(L-1)+(L-1)*NM]))*MACHEP;
  if ( S =  0.0 ) 
   then S := NORM*MACHEP;
  if ( Abs(H[(L-1)+(L-2)*NM]) <=  S ) 
   then goto _60;
_50:
 end;
{    OPMPOBAHE  CBA }
_60:
X := H[(EN-1)+(EN-1)*NM];
if ( L =  EN ) 
 then goto _210;
Y := H[(NA-1)+(NA-1)*NM];
W := H[(EN-1)+(NA-1)*NM]*H[(NA-1)+(EN-1)*NM];
if ( L =  NA ) 
 then goto _220;
if ( ITS =  30 ) 
 then goto _250;
if ( ITS <>  10 ) and (  ITS <>  20 ) 
 then goto _80;
{    OPMPOBAHE . CBA }
T := T + X;
for I:=LOW to EN do
 begin
  H[(I-1)+(I-1)*NM] := H[(I-1)+(I-1)*NM] - X;
_70:
 end;
S := Abs(H[(EN-1)+(NA-1)*NM]) + Abs(H[(NA-1)+(ENM2-1)*NM]);
X := 0.75*S;
Y := X;
X := -0.4375*S*S;
_80:
ITS := ITS + 1;
{ ******OCK BX COCEHX MAX O BEHE }
{      OAOHAHX EMEHTOB. }
{       M=EN-2 C M OT -1 O L }
for MM:=L to ENM2 do
 begin
  M := ENM2 + L - MM;
  ZZ := H[(M-1)+(M-1)*NM];
  R := X - ZZ;
  S := Y - ZZ;
  P := (R*S - W)/H[(M+0)+(M-1)*NM] + H[(M-1)+(M+0)*NM];
  Q := H[(M+0)+(M+0)*NM] - ZZ - R - S;
  R := H[(M+1)+(M+0)*NM];
  S := Abs(P) + Abs(Q) + Abs(R);
  P := P/S;
  Q := Q/S;
  R := R/S;
  if ( M =  L ) 
   then goto _100;
  ZZ := Abs(H[(M-2)+(M-2)*NM]) + Abs(ZZ) + Abs(H[(M+1-1)+(
    M+1-1)*NM]);
  if ( ZZ*MACHEP =  0.0 ) 
   then ZZ := NORM;
  if ( Abs(H[(M-1)+(M-2)*NM])*(Abs(Q) + Abs(R)) <= 
       MACHEP*Abs(P)*ZZ ) 
   then goto _100;
_90:
 end;
_100:
MP2 := M + 2;
for I:=MP2 to EN do
 begin
  H[(I-1)+(I-3)*NM] := 0.0;
  if ( I =  MP2 )
   then goto _110;
  H[(I-1)+(I-4)*NM] := 0.0;
_110:
 end;
{    BOHO A QR-AOPTMA,BOHEM HA CTPOKAM C HOMEPAM OT L O }
{     CTOAM OT M O EN }
for K:=M to NA do
 begin
  NOTLAS := ( K <>  NA );
  LOG := ( not  NOTLAS );
  if ( K =  M )
   then goto _130;
  P := H[(K-1)+(K-2)*NM];
  Q := H[(K+0)+(K-2)*NM];
  R := 0.0;
  if ( NOTLAS )
   then R := H[(K+1)+(K-2)*NM];
  X := Abs(P) + Abs(Q) + Abs(R);
  if ( X >  SYS056 )
   then goto _120;
  H[(K-1)+(K-2)*NM] := 0.0;
  H[(K+0)+(K-2)*NM] := 0.0;
  if ( NOTLAS )
   then H[(K+1)+(K-2)*NM] := 0.0;
  goto _200;
_120:
  P := P/X;
  Q := Q/X;
  R := R/X;
_130:
  S := Sign(Sqrt(P*P+Q*Q+R*R),P);
  if ( K =  M )
   then goto _140;
  H[(K-1)+(K-2)*NM] := -S*X;
  goto _150;
_140:
  if ( L <>  M )
   then H[(K-1)+(K-2)*NM] := -H[(K-1)+(K-2)*NM];
_150:
  P := P + S;
  X := P/S;
  Y := Q/S;
  ZZ := R/S;
  Q := Q/P;
  R := R/P;
{ ******PEOPAOBAHE CTPOK }
  for J:=K to N do
   begin
    P := H[(K-1)+(J-1)*NM] + Q*H[(K+0)+(J-1)*NM];
    if ( LOG )
     then goto _160;
    P := P + R*H[(K+1)+(J-1)*NM];
    H[(K+1)+(J-1)*NM] := H[(K+1)+(J-1)*NM] - P*ZZ;
_160:
    H[(K+0)+(J-1)*NM] := H[(K+0)+(J-1)*NM] - P*Y;
    H[(K-1)+(J-1)*NM] := H[(K-1)+(J-1)*NM] - P*X;
_170:
   end;
  J := Min0(EN,K+3);
{ ******PEOPAOBAHE CTOOB****** }
  for I:=L to J do
   begin
    P := X*H[(I-1)+(K-1)*NM] + Y*H[(I-1)+(K+0)*NM];
    if ( LOG ) 
     then goto _180;
    P := P + ZZ*H[(I-1)+(K+1)*NM];
    H[(I-1)+(K+1)*NM] := H[(I-1)+(K+1)*NM] - P*R;
_180:
    H[(I-1)+(K+0)*NM] := H[(I-1)+(K+0)*NM] - P*Q;
    H[(I-1)+(K-1)*NM] := H[(I-1)+(K-1)*NM] - P;
_190:
   end;
_200:
 end;
goto _40;
{      BCEHO OHO COCTBEHHOE HAEHE }
_210:
WR[EN-1] := X + T;
WI[EN-1] := 0.0;
EN := NA;
goto _30;
{     BA COCTBEHHX HAEH }
_220:
P := (Y - X)/2.0;
Q := P*P + W;
ZZ := Sqrt(Abs(Q));
X := X + T;
if ( Q <  0.0 ) 
 then goto _230;
{     ECTBTEHA APA }
ZZ := P + Sign(ZZ,P);
WR[NA-1] := X + ZZ;
WR[EN-1] := WR[NA-1];
if ( ZZ <>  0.0 ) 
 then WR[EN-1] := X - W/ZZ;
WI[NA-1] := 0.0;
WI[EN-1] := 0.0;
goto _240;
{     KOMEKCHA APA }
_230:
WR[NA-1] := X + P;
WR[EN-1] := X + P;
WI[NA-1] := ZZ;
WI[EN-1] := -ZZ;
_240:
EN := ENM2;
goto _30;
{     3 TEPA }
_250:
IERR := EN;
_260:
if ( IERR <>  0 ) 
 then UTAE12(IERR,N,1);
end;

end.
